/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.ProdPrecioDAO;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.ProdPrecio;
import com.rjconsultores.ventaboletos.entidad.ProductoServicio;
import com.rjconsultores.ventaboletos.service.ProdPrecioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("prodPrecioService")
public class ProdPrecioServiceImpl implements ProdPrecioService {

    @Autowired
    private ProdPrecioDAO prodPrecioDAO;

    public List<ProdPrecio> obtenerTodos() {
        return prodPrecioDAO.obtenerTodos();
    }

    public ProdPrecio obtenerID(Integer id) {
        return prodPrecioDAO.obtenerID(id);
    }

    @Transactional
    public ProdPrecio suscribir(ProdPrecio entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return prodPrecioDAO.suscribir(entidad);
    }

    @Transactional
    public ProdPrecio actualizacion(ProdPrecio entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return prodPrecioDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(ProdPrecio entidad) {
        if (entidad.getProdprecio() == null) {
            return;
        }
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        prodPrecioDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Marca marca) {
        if (marca == null){
            return;
        }
        List<ProdPrecio> lsPrecios = prodPrecioDAO.buscar(marca);
        for (ProdPrecio pp : lsPrecios) {
            pp.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            pp.setFecmodif(Calendar.getInstance().getTime());
            pp.setActivo(Boolean.FALSE);

            prodPrecioDAO.actualizacion(pp);
        }
    }

    public List<ProdPrecio> buscar(Marca marca, ProductoServicio productoservicio) {
        return prodPrecioDAO.buscar(marca, productoservicio);
    }
}
